#
# spec file for package perl-Perl-Tidy
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-Perl-Tidy
Version:        20160302
Release:        2.5
#Upstream:  This package is free software; you can redistribute it and/or modify it under the terms of the "GNU General Public License". Please refer to the file "COPYING" for details.
%define cpan_name Perl-Tidy
Summary:        Parses and beautifies perl source
License:        GPL-2.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/Perl-Tidy/
Source0:        http://www.cpan.org/authors/id/S/SH/SHANCOCK/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
%{perl_requires}

%description
This module makes the functionality of the perltidy utility available to
perl scripts. Any or all of the input parameters may be omitted, in which
case the @ARGV array will be used to provide input parameters as described
in the perltidy(1) man page.

For example, the perltidy script is basically just this:

    use Perl::Tidy;
    Perl::Tidy::perltidy();

The call to *perltidy* returns a scalar *$error_flag* which is TRUE if an
error caused premature termination, and FALSE if the process ran to normal
completion. Additional discuss of errors is contained below in the ERROR
HANDLING section.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc BUGS CHANGES COPYING docs examples Makefile.npm pm2pl README TODO

%changelog
* Tue Mar  8 2016 coolo@suse.com
- updated to 20160302
  see /usr/share/doc/packages/perl-Perl-Tidy/CHANGES
    2016 03 02
  - RT #112534. Corrected a minor problem in which an unwanted newline
    was placed before the closing brace of an anonymous sub with
    a signature, if it was in a list.  Thanks to Dmytro Zagashev.
  - Corrected a minor problem in which occasional extra indentation was
    given to the closing brace of an anonymous sub in a list when the -lp
    parameter was set.
    2016 03 01
  - RT #104427. Added support for signatures.
  - RT #111512.  Changed global warning flag $^W = 1 to use warnings;
    Thanks to Dmytro Zagashev.
  - RT #110297, added support for new regexp modifier /n
    Thanks to Dmytro Zagashev.
  - RT #111519.  The -io (--indent-only) and -dac (--delete-all-comments)
    can now both be used in one pass. Thanks to Dmitry Veltishev.
  - Patch to avoid error message with 'catch' used by TryCatch, as in
    catch($err){
    [#] do something
    }
    Thanks to Nick Tonkin.
  - RT #32905, UTF-8 coding is now more robust. Thanks to qsimpleq
    and Dmytro for patches.
  - RT #106885. Added string bitwise operators ^. &. |. ~. ^.= &.= |.=
  - Fixed RT #107832 and #106492, lack of vertical alignment of two lines
    when -boc flag (break at old commas) is set.  This bug was
    inadvertantly introduced in previous bug fix RT #98902.
  - Some common extensions to Perl syntax are handled better.
    In particular, the following snippet is now foratted cleanly:
    method deposit( Num $amount) {
    $self->balance( $self->balance + $amount );
    }
    A new flag -xs (--extended-syntax) was added to enable this, and the default
    is to use -xs.
    In previous versions, and now only when -nxs is set, this snippet of code
    generates the following error message:
    "syntax error at ') {', didn't see one of: case elsif for foreach given if switch unless until when while"
* Sun Aug 23 2015 coolo@suse.com
- updated to 20150815
  see /usr/share/doc/packages/perl-Perl-Tidy/CHANGES
    2015 08 15
  - Fixed RT# 105484, Invalid warning about 'else' in 'switch' statement.  The
    warning happened if a 'case' statement did not use parens.
  - Fixed RT# 101547, misparse of // caused error message.  Also..
  - Fixed RT# 102371, misparse of // caused unwated space in //=
  - Fixed RT# 100871, "silent failure of HTML Output on Windows".
    Changed calls to tempfile() from:
    my ( $fh_tmp, $tmpfile ) = tempfile();
    to have the full path name:
    my ( $fh_tmp, $tmpfile ) = File::Temp::tempfile()
    because of problems in the Windows version reported by Dean Pearce.
  - Fixed RT# 99514, calling the perltidy module multiple times with
    a .perltidyrc file containing the parameter --output-line-ending
    caused a crash.  This was a glitch in the memoization logic.
  - Fixed RT#99961, multiple lines inside a cast block caused unwanted
    continuation indentation.
  - RT# 32905, broken handling of UTF-8 strings.
    A new flag -utf8 causes perltidy assume UTF-8 encoding for input and
    output of an io stream.  Thanks to Sebastian Podjasek for a patch.
    This feature may not work correctly in older versions of Perl.
    It worked in a linux version 5.10.1 but not in a Windows version 5.8.3 (but
    otherwise perltidy ran correctly).
  - Warning files now report perltidy VERSION. Suggested by John Karr.
  - Fixed long flag --nostack-closing-tokens (-nsct has always worked though).
    This was due to a typo.  This also fixed --nostack-opening-tokens to
    behave correctly.  Thanks to Rob Dixon.
* Mon Sep 15 2014 coolo@suse.com
- updated to 20140711
  - Fixed RT #94902: abbreviation parsing in .perltidyrc files was not
    working for multi-line abbreviations.  Thanks to Eric Fung for
    supplying a patch.
  - Fixed RT #95708, misparsing of a hash when the first key was a perl
    keyword, causing a semicolon to be incorrectly added.
  - Fixed RT #94338 for-loop in a parenthesized block-map.  A code block within
    parentheses of a map, sort, or grep function was being mistokenized.  In
    rare cases this could produce in an incorrect error message.  The fix will
    produce some minor formatting changes.  Thanks to Daniel Trizen
    discovering and documenting this.
  - Fixed RT #94354, excess indentation for stacked tokens.  Thanks to
    Colin Williams for supplying a patch.
  - Added support for experimental postfix dereferencing notation introduced in
    perl 5.20. RT #96021.
  - Updated documentation to clarify the behavior of the -io flag
    in response to RT #95709.  You can add -noll or -l=0 to prevent
    long comments from being outdented when -io is used.
  - Added a check to prevent a problem reported in RT #81866, where large
    scripts which had been compressed to a single line could not be formatted
    because of a check for VERSION for MakeMaker. The workaround was to
    use -nvpl, but this shouldn't be necessary now.
  - Fixed RT #96101; Closing brace of anonymous sub in a list was being
    indented.  For example, the closing brace of the anonymous sub below
    will now be lined up with the word 'callback'.  This problem
    occured if there was no comma after the closing brace of the anonymous sub.
    This update may cause minor changes to formatting of code with lists
    of anonymous subs, especially TK code.
* Fri Oct  4 2013 coolo@suse.com
- updated to 20130922
  - Fixed RT #88020. --converge was not working with wide characters.
  - Fixed RT #78156. package NAMESPACE VERSION syntax not accepted.
  - First attempt to fix RT #88588.  INDEX END tag change in pod2html breaks
    perltidy -html. I put in a patch which should work but I don't yet have
    a way of testing it.
* Tue Aug  6 2013 coolo@suse.com
- updated to 20130806
  - Fixed RT #87107, spelling
  - Fixed RT #87502, incorrect of parsing of smartmatch before hash brace
  - Added feature request RT #87330, trim whitespace after POD.
    The flag -trp (--trim-pod) will trim trailing whitespace from lines of POD
* Sat Jul 27 2013 coolo@suse.com
- updated to 20130717
  - Fixed RT #86929, #86930, missing lhs of assignment.
  - Fixed RT #84922, moved pod from Tidy.pm into Tidy.pod
* Sun Jun  9 2013 coolo@suse.com
- updated to 20121207
  - The flag -cab=n or --comma-arrow-breakpoints=n has been generalized
    to give better control over breaking open short containers.  The
    possible values are now:
    n=0 break at all commas after =>
    n=1 stable: break at all commas after => if container is open,
    EXCEPT FOR one-line containers
    n=2 break at all commas after =>, BUT try to form the maximum
    maximum one-line container lengths
    n=3 do not treat commas after => specially at all
    n=4 break everything: like n=0 but also break a short container with
    a => not followed by a comma
    n=5 stable: like n=1 but ALSO break at open one-line containers (default)
    New values n=4 and n=5 have been added to allow short blocks to be
    broken open.  The new default is n=5, stable.  It should more closely
    follow the breaks in the input file, and previously formatted code
    should remain unchanged.  If this causes problems use -cab=1 to recover
    the former behavior.  Thanks to Tony Maszeroski for the suggestion.
    To illustrate the need for the new options, if perltidy is given
    the following code, then the old default (-cab=1) was to close up
    the 'index' container even if it was open in the source.  The new
    default (-cab=5) will keep it open if it was open in the source.
    our $fancypkg = {
    'ALL' => {
    'index' => {
    'key' => 'value',
    },
    'alpine' => {
    'one'   => '+',
    'two'   => '+',
    'three' => '+',
    },
    }
    };
  - New debug flag --memoize (-mem).  This version contains a
    patch supplied by Jonathan Swartz which can significantly speed up
    repeated calls to Perl::Tidy::perltidy in a single process by caching
    the result of parsing the formatting parameters.  A factor of up to 10
    speedup was achieved for masontidy (https://metacpan.org/module/masontidy).
    The memoization patch is on by default but can be deactivated for
    testing with -nmem (or --no-memoize).
* Mon Dec 19 2011 coolo@suse.de
- update to 20101217
  - added new flag -it=n or --iterations=n
  - A configuration file pathname begins with three dots, e.g.
    ".../.perltidyrc", indicates that the file should be searched for starting
    in the current directory and working upwards.
  - Added flag --notidy which disables all formatting and causes the input to be
    copied unchanged.
  - Added prefilters and postfilters in the call to the Tidy.pm module.
  - The starting indentation level of sections of code entabbed with -et=n
    is correctly guessed if it was also produced with the same -et=n flag.  This
    keeps the indentation stable on repeated formatting passes within an editor.
    Thanks to Sam Kington and Glenn.
  - Functions with prototype '&' had a space between the function and opening peren.
  - Patch to never put spaces around a bare word in braces beginning with ^
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Wed Oct 13 2010 chris@computersalat.de
- noarch pkg
- recreated by cpanspec 1.78
* Wed Jan 20 2010 lars@linux-schulserver.de
- specfile cleanup
* Wed Jan 13 2010 cwh@suse.de
- initial version
